2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[ | list | show | apply | clear]'
10 TMP="$GIT_DIR/.git-stash.$$"
11 trap 'rm -f "$TMP-*"' 0
16 git diff-index --quiet --cached HEAD &&
17 git diff-files --quiet
21 logfile="$GIT_DIR/logs/$ref_stash" &&
22 mkdir -p "$(dirname "$logfile")" &&
31 echo >&2 'No local changes to save'
34 test -f "$GIT_DIR/logs/$ref_stash" ||
35 clear_stash || die "Cannot initialize stash"
37 # state of the base commit
38 if b_commit=$(git rev-parse --verify HEAD)
40 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
42 die "You do not have the initial commit yet"
45 if branch=$(git symbolic-ref -q HEAD)
47 branch=${branch#refs/heads/}
51 msg=$(printf '%s: %s' "$branch" "$head")
54 i_tree=$(git write-tree) &&
55 i_commit=$(printf 'index on %s' "$msg" |
56 git commit-tree $i_tree -p $b_commit) ||
57 die "Cannot save the current index state"
59 # state of the working tree
61 GIT_INDEX_FILE="$TMP-index" &&
62 export GIT_INDEX_FILE &&
65 git read-tree $i_tree &&
70 die "Cannot save the current worktree state"
73 if test -z "$stash_msg"
75 stash_msg=$(printf 'WIP on %s' "$msg")
77 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
79 w_commit=$(printf '%s\n' "$stash_msg" |
80 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
81 die "Cannot record working tree state"
83 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
84 die "Cannot save the current status"
85 printf >&2 'Saved "%s"\n' "$stash_msg"
89 git rev-parse --verify $ref_stash >/dev/null 2>&1
93 have_stash || return 0
94 git log --pretty=oneline -g "$@" $ref_stash |
95 sed -n -e 's/^[.0-9a-f]* refs\///p'
99 flags=$(git rev-parse --no-revs --flags "$@")
104 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
106 w_commit=$(git rev-parse --verify "$s") &&
107 b_commit=$(git rev-parse --verify "$s^") &&
108 git diff $flags $b_commit $w_commit
112 git diff-files --quiet ||
113 die 'Cannot restore on top of a dirty state'
115 # current index state
116 c_tree=$(git write-tree) ||
117 die 'Cannot apply a stash in the middle of a merge'
119 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
120 w_tree=$(git rev-parse --verify "$s:") &&
121 b_tree=$(git rev-parse --verify "$s^:") ||
122 die "$*: no valid stashed state found"
125 GITHEAD_$w_tree='Stashed changes' &&
126 GITHEAD_$c_tree='Updated upstream' &&
127 GITHEAD_$b_tree='Version stash was based on' &&
128 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
131 if git-merge-recursive $b_tree -- $c_tree $w_tree
135 git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
136 git read-tree --reset $c_tree &&
137 git update-index --add --stdin <"$a" ||
138 die "Cannot unstage modified files"
142 # Merge conflict; keep the exit status from merge-recursive
173 if test $# -gt 0 && test "$1" = save
177 save_stash "$*" && git-reset --hard